#!/usr/bin/perl
###########################################################
#
# (Start of header section.)
#
#
# Master Spambot Buster
#   Version 2.0
#
#   Version 1.0 completed July 7, 2003
#   Version 2.0 completed November 3, 2003
#
# Copyright 2003 Bontrager Connection, LLC
# http://BontragerConnection.com/
#
# Programmer:  William Bontrager
# Website: http://willmaster.com
# Email:  william@willmaster.com
#
# 1. This software is provided as-is. 
# 2. There are no guarantees or warranties 
#       of any kind, expressed or implied. 
# 3. Use the software only at your own risk.
#
# You MUST AGREE TO THE THREE STATEMENTS ABOVE 
#    before installing or using this software.
#
#
# Installation:
#
# A. Verify the first line of this script points to the location 
#    of perl on your server.
#
# B. Upload this script to your server into a directory allowed 
#    to run Perl CGI scripts. Use an FTP program and upload 
#    the script as ASCII/plain text.
#
# C. Give the uploaded script 755 permissions.
#
# D. Type the URL of this script into your browser. I.E.:
#       http://example.com/cgi-bin/msb.cgi
#
#
# Distribution:
#
# This software is freeware. Feel free to give a copy to 
#    anyone you think might be able to use it.
#
# A link to download the latest version is at 
#    http://willmaster.com/master/spambotbuster/
#
# You may not charge for this software. You may give copies 
#    away. Distribution, installation, and/or remote hosting 
#    may be charged for, if such costs are incurred and if 
#    the charges are agreed to beforehand. But no charge may 
#    be made for the software itself.
#
# If you wish to brand the software with your own logo and/or 
#    name before giving it away, a link to a Branding Generator 
#    is at http://willmaster.com/master/spambotbuster/
#
#
# NOTE: Every copy of this software must contain the entirety 
#       of this header section, without editing.
#
#
# Master Spambot Buster was built for Unix/Linux servers.
#
# If you're running this script on a different server, two 
#    variables can be customized, $DataDirectory and $ME
#
#    $DataDirectory is at about line 86 and $ME at about 
#    line 113. (The line numbers may vary if this script 
#    had undergone changes.)
#
#
# (End of header section.)
#
###########################################################


# Version 1.1 changed the file name extensions of the password and email address database files.
# Version 1.11 changed two "can't create file" error messages.

# File locations:
my $DataDirectory = 'mSBdataDirectory'; # If using a non-Unix/Linux server, specify the 
                                        # complete directory path to the data directory.
my $AddyFile      = 'mSBaddyFile.cgi';
my $PassFile      = 'mSBpasswordFile.cgi';
my $l0AddyFile    = 'mSBaddyFile.txt';
my $l0PassFile    = 'mSBpasswordFile.txt';

# Cookie name:
my $CookieName = 'mSB';

# Branding information:
my $BrandingPosition    = 'top';
my $BrandingLink        = 'http://www.ezrabbit.com';
my $BrandingImage       = 'http://www.ezrabbit.com/images/head.gif';
my $BrandingImageWidth  = '774';
my $BrandingImageHeight = '124';
my $BrandingStatement   = '';

# Name, version, and copyright information (keep as-is):
my $OfficialName  = 'Master Spambot Buster';
my $Version       = '2.0';
my $CopyrightLine = 'Copyright 2003 <a href="http://BontragerConnection.com">Bontrager Connection, LLC &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</a>';

# Other variables global to this file:
my $LineBreakSubstitute = '$$LF$$';
my $HeaderPrinted    = 0;
my($QueryString,%In) = ();
my $ME = $0;
$ME =~ s!^.*[/\\](.*?)$!$1!; # If using a non-Unix/Linux server, replace this line with
                             #                     $ME = '__________________';
                             # where the underline is the absolute http://... URL to this script.

my $NoCanCreateFileMessage = <<NOCANCREATEFILEMESSAGE;
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="right" valign="top">Note</td>
<td>&nbsp;&nbsp;</td>
<td>
Some Unix/Linux server configurations won't allow Perl CGI programs to create directories and files within them if the program is running in a directory that itself doesn't have write permissions. If you think your server might be one of those, <a href="http://willmaster.com/master/spambotbuster/whatelse/">click here for a solution, presented on the tech support pages.</a>
</td>
</tr>
</table>
NOCANCREATEFILEMESSAGE

# Load modules:
my $LWP_Simple_mod_loaded = 0;
eval {   
	require LWP::Simple;
	LWP::Simple->import('get');
	$LWP_Simple_mod_loaded = 1;
};
use strict;


# Subroutines:

sub Exit { goto BOTTOM; }


sub Ten2Eleven # Convert 1.0 email database name to 1.1
{
	open rRtentonow,"<${DataDirectory}/$l0AddyFile";
	open wWtentonow,">${DataDirectory}/$AddyFile";
	print wWtentonow <rRtentonow>;
	close wWtentonow;
	close rRtentonow;
	unlink "${DataDirectory}/$l0AddyFile";
} # sub Ten2Now


sub LaunchEmailProgram
{
	unless(open Rlep,"<${DataDirectory}/$AddyFile")
	{
		if(-e "${DataDirectory}/$l0AddyFile")
		{
			Ten2Eleven;
			open Rlep,"<${DataDirectory}/$AddyFile";
		}
	}
	my @addylist = <Rlep>;
	close Rlep;
	chomp @addylist;
	$QueryString =~ s/\D//g;
	$QueryString = 1 unless $QueryString > 0;
	$QueryString = 1 if $QueryString > @addylist;
	$QueryString--;
	my(undef,$addy) = split /\t/,$addylist[$QueryString];
	ErrorHTML(qq~No email address has been specified in the <nobr><span class="bold">$OfficialName</span></nobr> control panel.~) unless $addylist[$QueryString] =~ /\w/;
	my $qm = quotemeta $LineBreakSubstitute;
	$addylist[$QueryString] =~ s/$qm/\%0A/sig;
	print "Location: mailto:$addylist[$QueryString]\r\n\r\n";
	Exit();
} # sub LaunchEmailProgram



sub Parse
{
	if ($ENV{REQUEST_METHOD} eq 'GET') { $QueryString = $ENV{QUERY_STRING}; }
	else { read(STDIN,$QueryString,$ENV{CONTENT_LENGTH}); }
	my @p = split(/&/,$QueryString);
	foreach(@p)
	{
		$_ =~ tr/+/ /;
		my ($n,$v) = split(/=/,$_,2);
		$n =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$v =~ s/\<(.*?)(embed|object|script|applet)(.*?)\>/\&lt\;1$2$3\&gt\;/gis;
		$v =~ s/\t/     /g;
		if($In{$n}) { $In{$n} .= "\t$v"; }
		else { $In{$n} = $v; }
	}
} # sub Parse



sub LockFile
{
	my $f = "$_[0].lock";
	my $tm = time;
	while((time - $tm) < 12)
	{
		last unless -e $f;
		sleep 2;
	}
	open LOCKFILE,">$f";
	close LOCKFILE;
} # sub LockFile
sub UnLockFile { unlink "$_[0].lock"; }



sub ContentHeader
{
	return if $HeaderPrinted;
	print "Content-type: text/html\n";
	$HeaderPrinted = 1;
} # sub ContentHeader



sub GetCookie
{
	my @tc = split(/\;/,$ENV{HTTP_COOKIE});
	my ($n,$value);
	for(@tc)
	{
		($n,$value) = split(/\=/,$_,2);
		last if $n eq $CookieName;
	}
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
	return $value;
} # sub GetCookie



sub SetCookie
{
	my $value = shift;
	$value =~ s/(\W)/'%'.unpack('H2',$1)/ges;
	ContentHeader;
	print "Set-Cookie: $CookieName=$value\n";
} # sub SetCookie




sub Stretch
{
	my @s = split //,$_[0];
	for(@s) { $_ = '&nbsp;' if / /; }
	return join ' ',@s;
} # sub Stretch



sub PageTop
{
	my($title,$omitTD) = @_;
	my $td = $omitTD ? '' : '<TD>';
	my $stretchVersion = Stretch("Version $Version");
	my $stretchName = Stretch($OfficialName);
	my $name = qq~<nobr><span class="likeh3">$stretchName</span></nobr><br><nobr><span class="small">$stretchVersion</span></nobr>~;
	my $nameboxed = qq~<table border="1" cellpadding="6" cellspacing="0"><tr><td align="center"><nobr><span class="likeh3">$stretchName</span></nobr><br><nobr><span class="small">$stretchVersion</span></nobr></td></tr></table>~;
	my $masthead = '';
	if($BrandingPosition eq 'upperleft')
	{
		$masthead = <<MASTHEAD;
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td width="$BrandingImageWidth" valign="top" align="center"><a href="$BrandingLink"><img src="$BrandingImage" height="$BrandingImageHeight" width="$BrandingImageWidth" border="0"></a><br>
<span class="bold"><a href="$BrandingLink">$BrandingStatement</a></span></td>
<td width="22">&nbsp;</td>
<td align="center" valign="bottom">
$name
<h3>Control Panel</h3>
<h2><nobr>$title</nobr></h2>
</td>
<td width="22">&nbsp;</td>
<td width="$BrandingImageWidth">&nbsp;</td>
</tr>
</table>
MASTHEAD
	}
	elsif($BrandingPosition eq 'upperright')
	{
		$masthead = <<MASTHEAD;
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td width="$BrandingImageWidth">&nbsp;</td>
<td width="22">&nbsp;</td>
<td align="center" valign="bottom">
$name
<h3>Control Panel</h3>
<h2><nobr>$title</nobr></h2>
</td>
<td width="22">&nbsp;</td>
<td width="$BrandingImageWidth" valign="top" align="center"><a href="$BrandingLink"><img src="$BrandingImage" height="$BrandingImageHeight" width="$BrandingImageWidth" border="0"></a><br>
<span class="bold"><a href="$BrandingLink">$BrandingStatement</a></span></td>
</tr>
</table>
MASTHEAD
	}
	elsif($BrandingPosition eq 'top')
	{
		my $brandingStatement = $BrandingStatement ? qq~<br><span class="bold"><a href="$BrandingLink">$BrandingStatement</a></span>~ : '';
		$masthead = <<MASTHEAD;
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="center">
<a href="$BrandingLink"><img src="$BrandingImage" height="$BrandingImageHeight" width="$BrandingImageWidth" border="0"></a>$brandingStatement
<br>&nbsp;<br>
$nameboxed
<h3>Control Panel</h3>
<h2><nobr>$title</nobr></h2>
</td>
</tr>
</table>
MASTHEAD
	}
	else
	{
		$masthead = <<MASTHEAD;
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="center">
$name
<h3>Control Panel</h3>
<h2><nobr>$title</nobr></h2>
</td>
</tr>
</table>
MASTHEAD
	}
	ContentHeader;
	print "\n";
	print <<HTML;
<html>
<head>
<title>$OfficialName Control Panel</title>
<STYLE TYPE="text/css">
<!--
BODY, TABLE, TR, TD, P, LI, OL, UL, BLOCKQUOTE, .normal
              { font-family: arial,helvetica,sans-serif; font-size: 12px; font-weight: normal; }
TH            {                                          font-size: 10px; font-weight: bold;   }
H1            {                                          font-size: 18px; font-weight: bold;   }
H2            {                                          font-size: 18px; font-weight: normal; }
H3            {                                          font-size: 14px; font-weight: bold;   }
H4            {                                          font-size: 14px; font-weight: normal; }
H5            {                                          font-size: 12px; font-weight: bold;   }
INPUT, TEXTAREA, .formtext
              { font-family: monospace,courier;                                                }
PRE, .inlinepre
              { font-family: courier,monospace;          font-size: 14px;                      }
.italic       {                          font-style: italic;                                   }
.bold         {                                                           font-weight: bold;   }
.bolditalic   {                          font-style: italic;              font-weight: bold;   }
.likeh2       {                                          font-size: 18px; font-weight: normal; }
.likeh3       {                                          font-size: 14px; font-weight: bold;   }
.big          {                                          font-size: 22px; font-weight: bold;   }
.small        {                                          font-size: 10px;                      }
.submitbutton { font-family: arial,helvetica,sans-serif; font-size: 14px; color: blue; font-weight: normal; line-height: 18px; }
.halfspace    { line-height: 6px; }
.error        { color: red;    text-decoration: none; }
A:link        { color: blue;   text-decoration: none; }
A:visited     { color: purple; text-decoration: none; }
A:active      { color: red;    text-decoration: none; background: yellow; }
A:hover       { color: red;    text-decoration: none; background: pink;   font-weight: bold; }
-->
</STYLE>
</head>
<body bgcolor="white">
<div align="center">
$masthead
&nbsp;
<form name="melcp" method="POST" action="$ME">
<TABLE WIDTH="500" BORDER="1" CELLPADDING="33" CELLSPACING="0"><TR>$td
HTML
} # sub PageTop



sub PageBottom
{
	print <<HTML;
</TD></TR></TABLE>
</form>
</div>
<p>
$CopyrightLine
</p>
</body></html>
HTML
	Exit();
} # sub PageBottom



sub ErrorHTML
{
	my $s = join qq~</li>\n<li class="error">~,@_;
	PageTop('Message for You');
	print qq~<ul><li class="error">$s</li></ul>~;
	PageBottom;
} # sub ErrorHTML



sub GetNewPassword
{
	SetCookie('');
	PageTop('Assign a New Password');
	print <<HTML;
<p>
The password you type here will be required for future access to the $OfficialName control panel.
</p>
<p>
The password may contain spaces and non-alphanumeric printable characters. 
The password is case sensitive: 
<nobr><span class="inlinepre">ab/c</span> is not the same as <span class="inlinepre">ab/C</span></nobr>
</p>
<div align="center">
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="right">New Password: <input type="password" name="pw" size="22"><br>
Type it again: <input type="password" name="pwc" size="22"></td>
</tr>
</table>
&nbsp;<br>
<input type="hidden" name="newpassword" value="yes">
<span class="submitbutton"><input class="submitbutton" type="submit" value="Record My New Password"></span>
</div>
<p>
(If you forget your password, delete file 
<nobr><span class="bold">${DataDirectory}/$PassFile</span></nobr> 
from your server. Then access the control panel, at which point $OfficialName 
will ask you to assign a password for future access.)
</p>
<script type="text/javascript" language="JavaScript"><!--
document.melcp.pw.focus();
//--></script>
HTML
	PageBottom;
} # sub GetNewPassword



sub RecordNewPassword
{
	mkdir($DataDirectory,0766) unless -d $DataDirectory;
	ErrorHTML('Please provide a password, typed in both places.') unless $In{pw} =~ /\w/ and $In{pwc} =~ /\w/;
	ErrorHTML('The password typed in the two places don\'t match. Both must be typed the same.') unless $In{pw} eq $In{pwc};
	open Wrnp,">${DataDirectory}/$PassFile" or ErrorHTML(qq~Unable to create the password file <nobr><span class="bold">${DataDirectory}/$PassFile</span></nobr>~,$NoCanCreateFileMessage);
	print Wrnp $In{pw};
	close Wrnp;
	SetCookie($In{pw});
} # sub RecordNewPassword



sub GetLogIn
{
	SetCookie('');
	my $thing = shift;
	$thing = qq~<div align="center"><table border="1" cellpadding="11" cellspacing="0"><tr><td align="center">Sorry, <span class="bold">$In{pw}</span> is incorrect.<br>Please try again.</td></tr></table></div>~ if $thing =~ /\w/;
	unless(-e "${DataDirectory}/$PassFile")
	{
		unlink "${DataDirectory}/$l0PassFile" if -e "${DataDirectory}/$l0PassFile";
		GetNewPassword;
	}
	PageTop('Log In');
	print <<HTML;
$thing
<p>
Please provide the password for access to the $OfficialName control panel.
</p>
<div align="center">
<p>
Password: <input type="password" name="pw" size="22">
</p>
<p>
<input type="hidden" name="login" value="yes">
<span class="submitbutton"><input class="submitbutton" type="submit" value="   Log In   "></span>
</p>
</div>
<p>
(If you forgot your password, delete file 
<nobr><span class="bold">${DataDirectory}/$PassFile</span></nobr> 
from your server. Then access the control panel, at which point $OfficialName 
will ask you to assign a password for future access.)
</p>
<script type="text/javascript" language="JavaScript"><!--
document.melcp.pw.focus();
//--></script>
HTML
	PageBottom;
} # sub GetLogIn



sub RecordLogIn
{
	open Rrli,"<${DataDirectory}/$PassFile";
	my $pw = <Rrli>;
	close Rrli;
	GetLogIn('try again') unless $pw eq $In{pw};
	SetCookie($In{pw});
} # sub RecordLogIn



sub VerifyPassword
{
	my $pw = $In{pw} ? $In{pw} : GetCookie;
	GetLogIn unless $pw;
} # sub VerifyPassword




sub ValidEmail
{
	return 0 if $_[0] =~ /(?:[\.\-\_]{2,})|(?:@[\.\-\_])|(?:[\.\-\_]@)|(?:\A\.)/;
	return 1 if $_[0] =~ /^[\w\.\-\_]+\@\[?[\w\.\-\_]+\.(?:[\w\.\-\_]{2,}|[0-9])\]?$/;
	return 0;
} # sub ValidEmail



sub UpdateEmailList
{
	unless(open Ruel,"<${DataDirectory}/$AddyFile")
	{
		if(-e "${DataDirectory}/$l0AddyFile")
		{
			Ten2Eleven;
			open Ruel,"<${DataDirectory}/$AddyFile";
		}
	}
	my @addylist = <Ruel>;
	close Ruel;
	chomp @addylist;
	my $rows = $#addylist + 5;
	$rows = 13 if $rows > 13;
	my $addyList = join "\n",@addylist;
	PageTop('Update Email Address List');
	print <<HTML;
<p>
List the email addresses you want to cloak.
Separate addresses with one or more spaces, commas, and/or line breaks. 
(Email subject, cc, bcc, and even body content can be specified the way 
you would in a regular email link of that type.)
</p>
<div align="center">
<p>
<textarea name="addylist" rows="$rows" cols="55" wrap="off" NOWRAP>$addyList
</textarea>
</p>
<p>
<input type="hidden" name="recordupdate" value="yes">
<span class="submitbutton"><input class="submitbutton" type="submit" value="Update Email Address List"></span>
</p>
</div>
<script type="text/javascript" language="JavaScript"><!--
document.melcp.addylist.focus();
//--></script>
HTML
	PageBottom;
} # sub UpdateEmailList



sub RecordUpdate
{
	$In{addylist} =~ s/^[\s\,]*(.*?)[\s\,]*$/$1/s;
	my @addylist = split /[\s\,]+/,$In{addylist};
	ErrorHTML('Please provide at least one email address.') unless $addylist[0] =~ /\w/;
	my @e = ();
	for my $addy (@addylist)
	{
		my $a = $addy;
		$a =~ s/\?.*$//;
		push @e,qq~Entry <span class="bold">$addy</span> is not a valid email address.~ unless ValidEmail($a);
	}
	ErrorHTML(@e) if @e;
	mkdir($DataDirectory,766) unless -d $DataDirectory;
	open Wru,">${DataDirectory}/$AddyFile" or ErrorHTML(qq~Unable to create/update database file <nobr><span class="bold">${DataDirectory}/$AddyFile</span></nobr>~,$NoCanCreateFileMessage);
	print Wru join "\n",@addylist;
	close Wru;
} # sub RecordUpdate



sub GenerateCode
{
	unless(open Rgc,"<${DataDirectory}/$AddyFile")
	{
		if(-e "${DataDirectory}/$l0AddyFile")
		{
			Ten2Eleven;
			open Rgc,"<${DataDirectory}/$AddyFile";
		}
	}
	my @addylist = <Rgc>;
	close Rgc;
	chomp @addylist;
	ErrorHTML('There needs to be at least one address in the email list before code can be generated.') unless @addylist;
	my $choices = q~<p class="bold">Check the radio button next to the position for which you want code generated:</p><p>~;
	if($#addylist == 0) { $choices = qq~<p class="bold"><input type="hidden" name="position" value="1">Generate code for the only address in the email address list: $addylist[0]~; }
	else
	{
		for(0..$#addylist)
		{
			my $position = $_ + 1;
			$choices .= qq~\n<input type="radio" name="position" value="$position">Position $position: $addylist[$_]<br>~;
		}
	}
	$choices .= '</p>';
	PageTop('Generate Code');
	print <<HTML;
$choices
<p class="bold">
Check the box or boxes for the type of code you want generated:
</p>
<p>
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="right" valign="top"><input type="radio" name="format" value="textmessage"></td>
<td>
<span class="bold">Plain text:</span><br>
For use in text messages and emails. 
</td>
</tr>
<tr><td colspan="2" class="halfspace">&nbsp;</td></tr>
<tr>
<td align="right" valign="top"><input type="radio" name="format" value="HTMLemail"></td>
<td>
<span class="bold">HTML source code:</span><br>
For use in HTML documents that will not be displayed in a web page browser.
</td>
</tr>
<tr><td colspan="2" class="halfspace">&nbsp;</td></tr>
<tr>
<td align="right" valign="top"><input type="radio" name="format" value="webpage"></td>
<td>
<span class="bold">Web page source code:</span><br>
For use on web pages made for web page browsers.
</td>
</tr>
</table>
</p>
<p align="center">
<input type="hidden" name="generatechoice" value="yes">
<script type="text/javascript" language="JavaScript"><!--
document.writeln('<input type="hidden" name="hreferrer" value="' + document.URL + '">');
//--></script>
<span class="submitbutton"><input class="submitbutton" type="submit" value="Generate the Code"></span>
</p>
HTML
	PageBottom;
} # sub GenerateCode



sub DoGenerateCode
{
	my @e = ();
	push @e,'One of the &quot;position&quot; radio buttons must be checked for which to generate code.' unless $In{position};
	push @e,'At least one of the checkboxes must be checked for the type of code you want generated.' unless $In{format};
	ErrorHTML(@e) if @e;
	my @formats = split /\t/,$In{format};
	my $assumedURL = '';
	if($In{hreferrer} =~ /\w/ and ($In{hreferrer} ne 'undefined'))
	{
		$assumedURL = $In{hreferrer};
		$assumedURL =~ s/^(.*?)(:?\?.*)?$/$1/;
	}
	else
	{
		my $domain = '';
		if   ($ENV{HTTP_HOST}   =~ /\w/) { $domain = "http://$ENV{HTTP_HOST}";   }
		elsif($ENV{SERVER_NAME} =~ /\w/) { $domain = "http://$ENV{SERVER_NAME}"; }
		$assumedURL = $ENV{REQUEST_URI} =~ /^http/i ? $ENV{REQUEST_URI} : "$domain$ENV{REQUEST_URI}";
	}
	$assumedURL = "http://yourdomain.com/cgi-bin/$ME" unless $assumedURL =~ /^http/i;
	my $code = '';
	for(@formats)
	{
		$code .= '<tr><td>';
		if(/textmessage/)
		{
			$code .= '<h3>Plain text:</h3>';
			my $position = "\?$In{position}";
			my $shortcode = "$assumedURL$position";
			$shortcode =~ s/\"/\&quot\;/g;
			$shortcode =~ s/\</\&lt\;/g;
			$shortcode =~ s/\>/\&gt\;/g;
			$code .= <<CODE;
<p>
For use in text messages and emails.
</p>
<pre>$shortcode</pre>
<textarea cols="70" rows="2" NOWRAP wrap="off">$shortcode
</textarea><br>&nbsp;
CODE
		}
		elsif(/HTMLemail/)
		{
			$code .= '<h3>HTML source code:</h3>';
			my $position = "\?$In{position}";
			my $shortcode = "$assumedURL$position";
			$shortcode = qq~<a href="$shortcode">\nClick Here To Email Me\n</a>~;
			$shortcode =~ s/\"/\&quot\;/g;
			$shortcode =~ s/\</\&lt\;/g;
			$shortcode =~ s/\>/\&gt\;/g;
			$code .= <<CODE;
<p>
For use in HTML documents that will not be displayed in a web page browser. 
Replace &quot;Click Here To Email Me&quot; with your own text and/or image.
</p>
<pre>$shortcode</pre>
<textarea cols="70" rows="4" NOWRAP wrap="off">$shortcode
</textarea><br>&nbsp;
CODE
		}
		elsif(/webpage/)
		{
			$code .= '<h3>Web page source code:</h3>';
			my $position = "\?$In{position}";
			my $url = "$assumedURL$position";
			my $winName = '';
			my $length = (int rand 10) + 5;
			my @characters = qw(a b C d e F G A h i E I j k L M n o O p q R S t T u v w W x y Z z);
			for(1..$length) { $winName .= $characters[int rand $#characters]; }
			$code .= <<INTRO;
<table width="500" border="0" cellpadding="0" cellspacing="0">
<tr>
<td>
<p>
For use on web pages made for web page browsers.
</p>
<p>
The code has two parts:
</p>
<ol>
<li>The JavaScript function code.</li>
<li>The link.</li>
</ol>
<p class="bold">The JavaScript function code.</p>
<p>
The JavaScript function code can be put anywhere on your page 
above the first use of the link &#151; 
in the HEAD area, in the BODY area, it really doesn't matter, so long as it is 
<span class="bold">somewhere above the first use of the link.</span>
</p>
</td>
</tr>
</table>
INTRO
			my $shortcode = qq~<script language="JavaScript"><!--
function F${winName}() {
${winName} = window.open('${url}','','height=100,width=100,dependent=yes');
${winName}.blur(); self.focus(); setTimeout('${winName}.close()',10000);
}//--></script>~;
			$shortcode =~ s/\"/\&quot\;/g;
			$shortcode =~ s/\</\&lt\;/g;
			$shortcode =~ s/\>/\&gt\;/g;
			$code .= <<CODE;
<pre>$shortcode</pre>
<textarea cols="70" rows="6" NOWRAP wrap="off">$shortcode
</textarea><br>&nbsp;
CODE
			$code .= <<INTRO;
<table width="500" border="0" cellpadding="0" cellspacing="0">
<tr>
<td>
<p class="bold">&nbsp;<br>The link.</p>
<p>
Put this sourece code where you want the link to display on your web page. 
Replace &quot;Click Here To Email Me&quot; with your own text and/or image.
</p>
<p>
The link can actually be put in several places, if you wish, so long as the 
JavaScript function code is above the first use of the link.
</p>
</td>
</tr>
</table>
INTRO
			$shortcode = qq~<a href="javascript:F${winName}()">Click Here To Email Me</a>~;
			$shortcode =~ s/\"/\&quot\;/g;
			$shortcode =~ s/\</\&lt\;/g;
			$shortcode =~ s/\>/\&gt\;/g;
			$code .= <<CODE;
<pre>$shortcode</pre>
<textarea cols="70" rows="2" NOWRAP wrap="off">$shortcode
</textarea><br>&nbsp;
CODE
		}
		$code .= '</td></tr>';
	}
	PageTop('Generated Code');
	print <<HTML;
<table width="500" border="0" cellpadding="0" cellspacing="0">
<tr>
<td>
<p>
In the code, below, it is assumed that the URL to this $ME program is 
<nobr><span class="bold">$assumedURL</span></nobr> (I can't see your 
browser's address bar like you <nobr>can&nbsp;&lt;grin&gt;).</nobr> If the URL is different 
than my assumption, replace the assumed URL with the actual.
</p>
<p>
The code is presented in two ways:
</p>
<ol type="i">
<li>Within a form textarea field.</li>
<li>As preformatted text.</li>
</ol>
<p>
Use whichever is easiest for you to copy and paste.
</p>
</td>
</tr>
</table>
&nbsp;<br>&nbsp;
<table border="1" cellpadding="11" cellspacing="0">
$code
</table>
&nbsp;
<p align="center">
<span class="submitbutton"><input class="submitbutton" type="submit" value="Return to the Control Panel Index Page"></span>
</p>
HTML
	PageBottom;
} # sub DoGenerateCode



sub InstallInstaller
{
# To install the CGI program installer --
#    First, log into the Master Email Link control panel. 
#    Then, append the following to the script name of the URL in your browser:
#
#             ?installer=yes
#
	use Fcntl;
	my $msCGIpiName = 'Master Series CGI Program Installer';
	ErrorHTML(q~I'm sorry, but your server doesn't have the <span class="bold">standard CPAN Perl module LWP::Simple</span> installed.~,q~Please ask your hosting company to install the <span class="bold">LWP::Simple</span> module for you (and for their other clients on the server). More information can be found at URL <a href="http://MasterCGI.com/faq/">http://MasterCGI.com/faq/ in answer to the question about installing Perl modules</a>.~) unless $LWP_Simple_mod_loaded;
	my $file = get('http://willmaster.com/master/installer/original/installer.original.txt');
	ErrorHTML('Sorry, but I was unable to retrieve the CGI program to install.') unless length $file > 10;
	ErrorHTML("<pre>$file</pre>") if $file =~ /^\s*\-\- Sorry/i;
	$file =~ /^(.*)/;
	my $fileName = $1;
	my $alreadyInstalledQuestion = q~I'm sorry, but a file by the name of $fileName already exists. Maybe the $msCGIpiName has already been installed?~;
	ErrorHTML($alreadyInstalledQuestion,qq~<a href="$fileName">URL: <span class="bold">$fileName</span></a>~) if -e $fileName;
	open Rii,"<$ME";
	my $perlLocation = <Rii>;
	close Rii;
	ErrorHTML(qq~I'm sorry, but I am unable to read this $ME program file, which is required for obtaining the first line of the program, the perl location, for the $msCGIpiName.~) unless length $perlLocation > 5;
	ErrorHTML(q~I'm sorry, but the $msCGIpiName has been created only for use on Unix/Linux servers.~) if $perlLocation =~ /^\#\!?[A-Za-z]+\:/ or $perlLocation !~ /perl/ or $perlLocation =~ /\.exe$/ or $ENV{WINDIR} =~ /\w/;
	$fileName =~ s/^\s*(.*?)\s*$/$1/s;
	$perlLocation =~ s/^\s*(.*?)\s*$/$1/s;
	$file =~ s/\r//sg;
	$file =~ s/^\Q$fileName/$perlLocation/;
	my $finalLocation = $fileName;
	if(sysopen(Wii,$finalLocation,O_RDWR|O_CREAT,0755))
	{
		print Wii $file;
		close Wii;
	}
	else
	{
		$finalLocation =~ s/\..*?$//;
		$finalLocation =~ s/\W//g;
		mkdir($finalLocation,0755);
		ErrorHTML(qq~I was unable to save the $msCGIpiName in the current directory. So I tried to create a special directory to put the $msCGIpiName into. But I can't create the directory, either.~,'Sorry, the install failed.',qq~You may wish to consult the <a href="http://willmaster.com/master/installer/techsupport/">$msCGIpiName tech support pages</a> for help installing the installer.~) unless -e $finalLocation and -d $finalLocation;
		$finalLocation = "${finalLocation}/$fileName";
		ErrorHTML($alreadyInstalledQuestion,qq~<a href="$finalLocation">URL: <span class="bold">$finalLocation</span></a>~) if -e $finalLocation;
		sysopen(Wii,$finalLocation,O_RDWR|O_CREAT,0755) or ErrorHTML(qq~Error creating file <nobr><span class="bold">$finalLocation</span></nobr>~,$!);
		print Wii $file;
		close Wii;
	}
	my $message = '';
	if(-e $finalLocation)
	{
		$message = <<MESSAGE;
<p>
Congratulations, <span class="bold">$msCGIpiName</span> has been installed.
</p>
<p>
Now, we need to verify that the installation was done correctly.
</p>
<p>
To do that, simply load $msCGIpiName into your browser. 
If it works, it works. 
If it doesn't, something is awry and 
<nobr><span class="bold"><a href="http://willmaster.com/master/installer/techsupport/">http://willmaster.com/master/installer/techsupport/</a></span></nobr> 
should be consulted.
</p>
<p>
To test the installation, <a href="$finalLocation">click here: $finalLocation &nbsp; &nbsp; &nbsp; &nbsp;</a><br>
(And remember to bookmark it.)
</p>
MESSAGE
	}
	else
	{
		$message = <<MESSAGE;
<p>
I'm sorry, but the install failed.
</p>
<p>
Not all servers are configured to allow CGI programs to create and update files and create directories. 
This is probably the reason the $msCGIpiName failed to install.
</p>
<p>
You might create a subdirectory in the cgi-bin, give the subdirectory 777 permissions, then do a manual installation in that subdirectory. See <nobr><span class="bold"><a href="http://willmaster.com/master/installer/">http://willmaster.com/master/installer/</a></span></nobr>
</p>
MESSAGE
	}
	PageTop("About the $msCGIpiName");
	print $message;
	PageBottom;
} # sub InstallInstaller



sub MainControlPanel
{
	my $instructionsLink = qq~<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME?verbose=yes">Verbose Instructions</a></nobr>
</td></tr></table>~;
	my $instructions = <<INSTRUCTIONS;
<span class="big">1. </span> 
Specify email address.
<div align="center">
<span class="big">2. </span> 
Generate the code.
</div>
<div align="right">
<span class="big">3. </span> 
Copy & paste the code.
</div>
&nbsp;
INSTRUCTIONS
	if($In{verbose} =~ /\w/)
	{
		$instructionsLink = qq~<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME">Sparse Instructions</a></nobr>
</td></tr></table>~;
		my $verboseURL = 'http://willmaster.com/master/spambotbuster/whatelse/verboseinstructions.txt';
		if($LWP_Simple_mod_loaded) { $instructions = get($verboseURL); }
		else
		{
			$instructions = <<FIRSTTIMER;
<p>
Because the Perl module LWP::Simple is not installed on your server 
(I couldn't find it, anyway), I was unable to retrieve the verbose 
instructions. If you would like to visit the verbose instructions 
page, they're at 
<a href="$verboseURL">$verboseURL</a>
</p>
FIRSTTIMER
		}
		while($instructions =~ /\[\[(.*?)\]\]/)
		{
			my $g = $1;
			my $g2 = quotemeta $g;
			my $flag = 0;
			my $if = '$flag = defined($' . $g . ')';
			eval "$if";
			my $s = '';
			if($flag)
			{
				my $ss = '$s = $' . $g;
				eval $ss;
			}
			$instructions =~ s/\[\[$g2\]\]/$s/g;
		}
		if(length $ME > 7 and $ME != /^http/i)
		{
			my $extension = $ME;
			$extension =~ s/^.*\.(.*?)$/$1/;
			$instructions .= <<NOTATION;
<table border="0" cellpadding="0" cellspacing="0">
<td align="right" valign="top" class="bold">Note:</td>
<td>&nbsp;&nbsp;</td>
<td>
If you want shorter links, this program's file name <span class="bold">$ME</span> 
can be changed to something like <span class="bold">a.$extension</span> 
or anything else ending with file name extension <span class="bold">.$extension</span> 
(If you've already published links generated with $ME, leave that file on the 
server for as long as you want the links to be valid.)
</td>
</tr>
</table>
NOTATION
		}
	}
	PageTop('Index Page');
	print <<HTML;
$instructions
<br>&nbsp;
<table width="434" border="0" cellpadding="0" cellspacing="0">
<tr>
<td width="201" valign="top">

<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME?emailupdate=yes">Email Addresses</a></nobr>
</td></tr></table>&nbsp;

<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME?generatecode=yes">Generate Code</a></nobr>
</td></tr></table>&nbsp;

$instructionsLink

</td><td width="32">&nbsp;</td><td width="201" valign="top">

<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME?changepassword=yes">Change Password</a></nobr>
</td></tr></table>&nbsp;

<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="$ME?logoff=yes">Log Off</a></nobr>
</td></tr></table>&nbsp;

<table width="100%" border="1" cellpadding="4" cellspacing="0"><tr><td align="center" class="likeh3">
<nobr><a href="http://willmaster.com/master/spambotbuster/whatelse/">Tech Support</a></nobr>
</td></tr></table>

</td>
</tr>
</table>
HTML
	PageBottom;
} # sub MainControlPanel



sub Switcher
{
SWITCHER:
	{
		if($In{newpassword})    { RecordNewPassword; last SWITCHER; }
		elsif($In{login})       { RecordLogIn;       last SWITCHER; }
		else                    { VerifyPassword;    }
		if($In{emailupdate})    { UpdateEmailList;   last SWITCHER; }
		if($In{recordupdate})   { RecordUpdate;      last SWITCHER; }
		if($In{generatecode})   { GenerateCode;      last SWITCHER; }
		if($In{generatechoice}) { DoGenerateCode;    last SWITCHER; }
		if($In{changepassword}) { GetNewPassword;    last SWITCHER; }
		if($In{logoff})         { GetLogIn;          last SWITCHER; }
		if($In{installer})      { InstallInstaller;  last SWITCHER; }
	} # SWITCHER
	MainControlPanel;
} # sub Switcher


# End of subroutines.

Parse;
LaunchEmailProgram if $QueryString =~ /^\d/;
Switcher;
BOTTOM:
# End of script.
